// Name.cpp : Defines the entry point for the console application.

#include "stdafx.h"
#include "Name.h"
#include "TreeList.h"
#include "DTree.h"
#include "CList.h"
#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CWinApp theApp;

//using namespace std;

class CExtension : public CString {
  int Count;
public:
  CCList* List; //Holds the numbers of correctly named files
  CExtension(CString S) : Count(0), List(0) {*((CString*)this)=S;}
 ~CExtension() {delete List;}
  int& operator++() { //return a new unused number
    if(List) { //if we have some non-adjacent correctly named files
      List->Home();
      WORD a=List->GetKey();
      if(a>1) {
        List->Add(1); //Theres space at the beginning.
        a=0;
      }else{
        for(;;) { //Look for a gap for our number
          if(!List->Next()) { //if there are no more gaps
            delete List; //stop using List, Count is enough.
            List=0;
            break;
          }
          WORD b=List->GetKey();
          if((b-a)>1) { //if we've found a gap, use it.
            List->Add(a+1);
            break;
          }
          a=b;
      } }
      Count=a;
    }
    return ++Count;
  }
};

class CNamer : public CDTreeBehaviour {
  CFile*    pFile;
  CArchive* pAr;
  CString   CurrentFolder;
  bool      IsFirstFile;
  int       FileCount;
  char      Count;
  CTreeList<CExtension> TreeList;
public:
  CNamer() : pAr(0), pFile(0), FileCount(0) {
    CString Path;
    DWORD Length=GetCurrentDirectory(0,0);
    GetCurrentDirectory(Length, Path.GetBufferSetLength(Length));
    Path.ReleaseBuffer();
    CurrentFolder=Path;
    int i=CurrentFolder.ReverseFind('\\')+1;
    CurrentFolder=i ? CurrentFolder.Mid(i) : "File";
    try {
      pFile=new CFile;
      bool WroteSome=false;
      if(pFile->Open("Name.bat",CFile::modeCreate|CFile::modeWrite|CFile::shareDenyNone)) {
        pAr=new CArchive(pFile, CArchive::store);
        puts("This will create a batch file called Name.bat\r\nwhich you can edit or just run to rename every file in this directory tree!\r\n");
        
        CDTree(Path, *this);
        
        pAr->Flush();
        if(pAr->GetFile()->GetPosition()) {
          WroteSome=true;
          pAr->WriteString("\r\nDel Name.txt\r\nRename Name.bat Name.txt\r\n");
          pAr->Flush();
          puts("Name.bat created.");
        }
      }else puts("Couldn't create Name.bat.");
      pFile->Close();
      if(WroteSome) {
        WinExec("NotePad.exe Name.bat", SW_SHOW);
        return;
      }else{
        DeleteFile("Name.bat");
        puts("All files are correctly named:");
        puts("No Name.bat file required.");
      }
      getch();
    }catch(...) {puts("Out of disk space writing Name.bat");}
  }
  virtual ~CNamer() {
    if(pAr)   delete pAr;
    if(pFile) delete pFile;
  }

  CString GetExtension(CString S) {
    int i=S.ReverseFind('.');
    if(i!=-1) S=S.Mid(i);
    S.MakeLower();
    return S;
  }

  int GetNumber(CString S) {
    int i=S.ReverseFind('.');
    if(i>3) {
      if(S.Left(i-3).CompareNoCase(CurrentFolder)) return -1;
      return atoi(S.Mid(i-3,3));
    }else if(i==-1 && S.GetLength()>3) { //No Extension Text
      if(S.Left(S.GetLength()-3).CompareNoCase(CurrentFolder)) return -1;
      return atoi(S.Right(3));
    }
    return -1;
  }

  void OnFile(CDTreeBase& DTree) {
    static const CString Extensions(".jpg.jpeg.gif.bmp.dib.tif.ico.cur.png.avi.mpg.mpeg.rm.ra.ram.mov.");
    if(DTree.IsReadOnly()) pAr->WriteString("Attrib -r "+DTree.GetShortPath()+"\r\n");
    CString S;
    if(IsFirstFile) { //Starting a new Directory: collect all correctly named files:
      IsFirstFile=false;
      CDTree DIR;
      if(DIR.GetList(DTree.GetPath())) {
        while(DIR.GetNext(S)) {
          if(DIR.IsDirectory()) {
          }else{
            CString Ext(GetExtension(S));
            if(Extensions.Find(Ext+'.')==-1) continue;
            int Number=GetNumber(S);
            if(Number==-1) continue;
            //If we get to here we have Number=the files number eg. 3 for Folder003.gif
            TreeList.Insert(new CExtension(Ext));
            CTreeListIterator<CExtension> it(TreeList);
            it.Find(CExtension(Ext));
            if(!(*it).List) (*it).List=new CCList;
            (*it).List->Add(Number);
    } } } }

    char* Tick=".o*O";
    putch(Tick[(++Count)&3]);
    putch('\r');

    CString Ext(GetExtension(DTree.GetName()));
    if(Extensions.Find(Ext+'.')==-1) return;
    if(GetNumber(DTree.GetName())!=-1) return; //Ignore correctly named files.
// We now have CurrentFolder, Ext and DTree.GetPath()+'\\'+DTree.GetName()
    TreeList.Insert(new CExtension(Ext));
    CTreeListIterator<CExtension> it(TreeList);
    it.Find(CExtension(Ext));
    S.Format("%s%03u%s", CurrentFolder, ++*it, *it);
//Needs to deal with folders that have new files with existing Named files afterwards in the sort order...
    if(S!=DTree.GetName()) pAr->WriteString("Rename \""+DTree.GetShortPath()+"\" \""+S+"\"\r\n");
  }
  void OnDIR (CDTreeBase& DTree) {
    if(DTree.IsReadOnly()) pAr->WriteString("Attrib -r "+DTree.GetShortPath()+"\r\n");
    CurrentFolder=DTree.GetName();
    TreeList.Empty();
    IsFirstFile=true;
  } 
  void OnUp  (CDTreeBase& DTree) {
    FileCount=0;
    int i=DTree.GetPath().ReverseFind('\\')+1;
    CurrentFolder=i ? DTree.GetPath().Mid(i) : "";
    TreeList.Empty();
    IsFirstFile=true;
  }
};

int __cdecl _tmain(int argc, TCHAR* argv[], TCHAR* envp[]) {
	if(!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0)) return 1; // initialize MFC
  CNamer();
	return 0;
}

